---
title: MutationObserverInit.attributes
slug: Web/API/MutationObserverInit/attributes
tags:
  - API
  - API Reference
  - Attributes
  - Changes
  - DOM
  - DOM WHATWG
  - MutationObserverInit
  - Observer
  - Property
  - Reference
  - mutation
---
<div>{{APIRef("DOM WHATWG")}}</div>

<p><span class="seoSummary">The <strong>{{domxref("MutationObserverInit")}}</strong> dictionary's optional <strong><code>attributes</code></strong> property is used to specify whether or not to watch for attribute value changes on the node or nodes being observed.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>options</em> = {
  <em>attributes</em>: true | false
}
</pre>

<h3 id="Value">Value</h3>

<p>A Boolean value indicating whether or not to report through the callback any changes to the values of attributes on the node or nodes being monitored. The default value is <code>false</code>.</p>

<p>If <code>true</code>, the callback specified when {{domxref("MutationObserver.observe", "observe()")}} was used to start observing the node or subtree will be called any time one or more attributes have changed on observed nodes.</p>

<p>You can expand the capabilities of attribute mutation monitoring using other options:</p>

<ul>
 <li>{{domxref("MutationObserverInit.attributeFilter", "attributeFilter")}} lets you specify specific attribute names to monitor instead of monitoring all attributes.</li>
 <li>{{domxref("MutationObserverInit.attributeOldValue", "attributeOldValue")}} lets you specify whether or not you want the previous value of changed attributes to be included in the {{domxref("MutationRecord")}}'s {{domxref("MutationRecord.oldValue", "oldValue")}} property.</li>
 <li>{{domxref("MutationObserverInit.subtree", "subtree")}} lets you specify whether to watch the target node and all of its descendants (<code>true</code>), or just the target node (<code>false</code>).</li>
</ul>

<p>If you set either <code>attributeFilter</code> or <code>attributeOldValue</code> to <code>true</code>, <code>attributes</code> is automatically assumed to be <code>true</code>, even if you don't expressly set it as such.</p>

<h2 id="Example">Example</h2>

<p>In this example, a Mutation Observer is set up to watch for changes to the <code>status</code> and <code>username</code> attributes in any elements contained within a subtree that displays the names of users in a chat room. This lets the code, for example, reflect changes to users' nicknames, or to mark them as away from keyboard (AFK) or offline.</p>

<pre class="brush: js">function callback(mutationList) {
  mutationList.forEach(function(mutation) {
    switch(mutation.type) {
      case "attributes":
        notifyUser("Attribute name " + mutation.attributeName +
            " changed to " + mutation.target[mutation.attributeName] +
            " (was " + mutation.oldValue + ")");
        break;
    }
  });
}

var targetNode = document.querySelector("#target");

var observer = new MutationObserver(callback);
observer.observe(targetNode, {
  attributes: true,
  attributeOldValue: true
});</pre>

<p>The <code>callback()</code> function—which will be passed into the {{domxref("MutationObserver.observe", "observe()")}} method when starting the observer, looks at each item in the list of {{domxref("MutationRecord")}} objects. For any items representing an attribute change (which can be detected by the value of {{domxref("MutationRecord.type")}} being <code>"attributes"</code>), a function called <code>notifyUser()</code> is used to tell the user the name of the attribute that changed as well as the attribute's new value (<code>mutation.target[mutation.attributeName]</code>) and its old value (<code>mutation.oldValue</code>).</p>

<p>When <code>observe()</code> is called, the specified options are <code>attributes</code> and <code>attributeOldValue</code>, which means that changes to attribute values will be reported, and each mutation record will include the {{domxref("MutationRecord.oldValue", "oldValue")}} property specifying the attribute's previous value.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-mutationobserverinit-attributes', 'MutationObserverInit.attributes')}}</td>
   <td>{{ Spec2('DOM WHATWG') }}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.MutationObserverInit.attributes")}}</p>
</div>
